#include "StdFilePkg.h"
#include "FileMgr.h"
#include "stdio.h"
#include "math.h"
#include "theErrors.h"


/****************************************** SaveBinaryFile */

SaveBinaryFile()
{
	SFReply	reply;
	int srcFile;
	long bytes;

	SaveFileName( &reply );
	if (reply.good)
	{
		WriteFileData( &reply );	
	}
	WriteASCII();
}

/****************************************** WriteFileData */

WriteFileData( replyPtr )

SFReply *replyPtr;

{
	int 	srcFile;
	OSErr 	theErr;
	Str255 	k;
	long 	siz;
	double t;
	double a1;
	double a2;
	int i;
	int j;
	

	theErr = Create( (*replyPtr).fName, (*replyPtr).vRefNum, '????', '????');
	if ((theErr == noErr) || (theErr == dupFNErr))
	{
		theErr = FSOpen( (*replyPtr).fName, (*replyPtr).vRefNum, &srcFile );
		if (theErr == noErr)
		{
			for (i=-10; i<=10; i++)
			{
				for (j=-10; j<=10; j++)
				{
					a1 = (double) i / 10.0 * PI;
					a2 = (double) j / 10.0 * PI;
					t = sin(a1) * cos(a2);
					siz = (long) sizeof(double);
					FSWrite( srcFile, &siz, &t );
				}
			}
			siz = (long) (21 * 21) * sizeof(double);
			SetFPos( srcFile, fsFromStart, 0L );
			SetEOF( srcFile, siz );
			FSClose( srcFile );
			FlushVol( 0L, (*replyPtr).vRefNum );
		}
	}
}


/****************************************** SaveFileName */

SaveFileName( replyPtr )

SFReply *replyPtr;

{
	Point 		thePoint;
	int 		numTypes;
	char		theName[256];
	char		prompt[256];
	
	sprintf(theName, "Binary Data 2\0");
	CtoPstr( (char *) theName);
	sprintf(prompt, "Save data as:\0");
	CtoPstr( (char *) prompt);
	thePoint.h = 50;
	thePoint.v = 50;
	numTypes = 1;
	SFPutFile( thePoint, prompt, theName, NIL_DIALOG_HOOK, replyPtr );
}


/* ----------------------------------------------------------------- */

WriteASCII()
{
	FILE *fp;
	char	path[256];
	int i;
	int j;
	double a1;
	double a2;
	double t;
	
	sprintf(path, "ASCII Data 2\0");
	fp = fopen(path, "w");
	for (i=-10; i<=10; i++)
	{
		for (j=-10; j<=10; j++)
		{
			a1 = (double) i / 10.0 * PI;
			a2 = (double) j / 10.0 * PI;
			t = sin(a1) * cos(a2);
			fprintf(fp, "%lf\n", t);
		}
	}
	fprintf(fp, "\n");
	fclose(fp);
}
